; FILENAME      XTOUCH.ASM
; DESCRIPTION   TOUCH MEMORY TEST PROGRAM
; HARDWARE      JAZZ-31 (P1.0=DATA)
; ASSEMBLER     SXA51
; START-DATE    08/04/40
; SOFTWARE ENG  KRIANGSAK B.
; COMPANY       SILA RESEARCH CO.,LTD.
;               TEL 712-2850-2 FAX 381-1447

         $INCLUDE "J31H2.ASM"

TMDAT    EQU    P1.0

; ********** MAIN **********

         ORG    8100H

TESTC:   CALL   TMRES             ;READ 512 BYTE DATA
         CALL   TMCHK
         JNC    TESTC
         MOV    R2,#1
         CALL   DTSEC
         CALL   TMRES
         CALL   TMCHK
         JNC    TESTC
         MOV    R2,#0
         DJNZ   R2,$

         MOV    DPTR,#9000H
         MOV    R4,#0
         MOV    R5,#0
         MOV    R7,#16
TESTC2:  CALL   TMRRAM
         MOV    A,R5
         ADD    A,#20H
         MOV    R5,A
         MOV    A,R4
         ADDC   A,#0
         MOV    R4,A
         DJNZ   R7,TESTC2
         LJMP   ENDVEC2

TESTB:   CALL   TMRES             ;WRITE 512 BYTE DATA
         CALL   TMCHK
         JNC    TESTB
         MOV    R2,#1
         CALL   DTSEC
         CALL   TMRES
         CALL   TMCHK
         JNC    TESTB
         MOV    R2,#0
         DJNZ   R2,$

         MOV    DPTR,#0000H
         MOV    R4,#0
         MOV    R5,#0
         MOV    R7,#16
TESTB2:  CALL   TMWRAM
         MOV    A,R5
         ADD    A,#20H
         MOV    R5,A
         MOV    A,R4
         ADDC   A,#0
         MOV    R4,A
         DJNZ   R7,TESTB2
         LJMP   ENDVEC2

TESTA:   CALL   TMRES             ;READ ROM-ID
         CALL   TMCHK
         JNC    TESTA
         MOV    R2,#1
         CALL   DTSEC
         CALL   TMRES
         CALL   TMCHK
         JNC    TESTA
         MOV    R2,#0
         DJNZ   R2,$

         MOV    DPTR,#9000H
         CALL   TMRROM
         LJMP   ENDVEC2

; ********** TMRROM SUB **********
; TOUCH MEMORY READ ROM-ID
; OUT = @DPTR  (8 BYTE BLOCK)
; REG = A,R2,R3,R4

TMRROM:  CALL   TMRES
         CALL   TMPRE
         MOV    R2,#0
         DJNZ   R2,$
         MOV    A,#33H            ;READ ROM
         CALL   TMWB
         MOV    R4,#8             ;8 BYTE
TMRROM1: CALL   TMRB
         MOVX   @DPTR,A
         INC    DPTR
         DJNZ   R4,TMRROM1
         CALL   TMRES
         CALL   TMPRE
         RET

; ********** TMWRAM SUB **********
; TOUCH MEMORY WRITE RAM
; IN  = R4,R5 ADDRESS
;     = @DPTR (32 BYTE BLOCK)
; REG = A,R2,R3,R4,R5,R6,DPTR

TMWRAM:  CALL   TMRES
         CALL   TMPRE
         MOV    R2,#0
         DJNZ   R2,$
         MOV    A,#0CCH           ;SKIP ROM
         CALL   TMWB
         MOV    A,#0FH            ;WRITE SCRATCHPAD
         CALL   TMWB
         MOV    A,R5
         CALL   TMWB
         MOV    A,R4
         CALL   TMWB

         MOV    R6,#32
TMWRAM1: MOVX   A,@DPTR
         CALL   TMWB
         INC    DPTR
         DJNZ   R6,TMWRAM1

         CALL   TMRES
         CALL   TMPRE
         MOV    R2,#0
         DJNZ   R2,$
         MOV    A,#0CCH           ;SKIP ROM
         CALL   TMWB
         MOV    A,#0AAH           ;READ SCRATCHPAD
         CALL   TMWB

         CALL   TMRB
         CALL   TMRB
         CALL   TMRB
         PUSH   ACC               ;--\
         MOV    R6,#32
TMWRAM2: CALL   TMRB
         DJNZ   R6,TMWRAM2

         CALL   TMRES
         CALL   TMPRE
         MOV    R2,#0
         DJNZ   R2,$
         MOV    A,#0CCH           ;SKIP ROM
         CALL   TMWB
         MOV    A,#55H            ;COPY SCRATCHPAD
         CALL   TMWB
         MOV    A,R5
         CALL   TMWB
         MOV    A,R4
         CALL   TMWB
         POP    ACC               ;--/
         CALL   TMWB

         MOV    R2,#30             ;65 uS (?)
TMWRAM4: NOP
         NOP
         DJNZ   R2,TMWRAM4
         CALL   TMRES
         CALL   TMPRE
         RET

; ********** TMRRAM SUB **********
; TOUCH MEMORY READ RAM
; IN  = R4,R5 ADDRESS
; OUT = @DPTR (32 BYTE BLOCK)
; REG = A,R2,R3,R4,R5,R6,DPTR

TMRRAM:  CALL   TMRES
         CALL   TMPRE
         MOV    R2,#0
         DJNZ   R2,$
         MOV    A,#0CCH           ;SKIP ROM
         CALL   TMWB
         MOV    A,#0F0H           ;READ MEMORY
         CALL   TMWB
         MOV    A,R5
         CALL   TMWB
         MOV    A,R4
         CALL   TMWB

         MOV    R6,#32
TMRRAM1: CALL   TMRB
         MOVX   @DPTR,A
         INC    DPTR
         DJNZ   R6,TMRRAM1

         CALL   TMRES
         CALL   TMPRE
         RET

; ********** TMRB SUB **********
; TOUCH MEMORY READ BYTE
; OUT = A
; REG = A,R2,R3

TMRB:    MOV    R3,#8             ;READ BYTE
TMRB1:   CALL   TMBIT
         RRC    A
         DJNZ   R3,TMRB1
         RET

TMBIT:   CLR    TMDAT             ;READ BIT
         NOP
         NOP
         SETB   TMDAT
         NOP
         NOP
         NOP
         NOP
         MOV    C,TMDAT
         MOV    R2,#15             ;65 uS
TMBIT2:  NOP
         NOP
         DJNZ   R2,TMBIT2
         RET

; ********** TMWB SUB **********
; TOUCH MEMORY WRITE BYTE
; IN  = A
; REG = A,R2,R3

TMWB:    MOV    R3,#8             ;WRITE BYTE
TMWB1:   RRC    A
         JC     TMWB2
         CALL   TMW0
         SJMP   TMWB3
TMWB2:   CALL   TMW1
TMWB3:   DJNZ   R3,TMWB1
         RET

TMW0:    CLR    TMDAT             ;WRITE 0
         MOV    R2,#15            ;65 uS
TMW01:   NOP
         NOP
         DJNZ   R2,TMW01
         SETB   TMDAT
         NOP                      ;4 uS
         NOP
         NOP
         NOP
         RET

TMW1:    CLR    TMDAT             ;WRITE 1
         NOP                      ;4 uS
         NOP
         NOP
         NOP
         SETB   TMDAT
         MOV    R2,#15            ;65 uS
TMW11:   NOP
         NOP
         DJNZ   R2,TMW11
         RET

; ********** TMRES SUB **********
; TOUCH MEMORY RESET
; REG = R2

TMRES:   CLR    TMDAT             ;RESET (TX)
         MOV    R2,#200           ;APP. 900 uS
TMRES1:  NOP
         NOP
         DJNZ   R2,TMRES1
         SETB   TMDAT
         MOV    R2,#8
         DJNZ   R2,$
         RET

; ********** TMPRE SUB **********
; TOUCH MEMORY PRESENCE
; REG = R2

TMPRE:   JB     TMDAT,$           ;PRESENCE (RX)
         JNB    TMDAT,$
         MOV    R2,#8
         DJNZ   R2,$
         RET

; ********** TMCHK SUB **********
; TOUCH MEMORY CHECK PRESENCE AT FIRST
; OUT = CY  0=NO 1=OK
; REG = R2,R3

TMCHK:   MOV    R2,#8
TMCHK1:  MOV    R3,#0
TMCHK2:  JNB    TMDAT,TMCHK5      ;PRESENCE (RX)
         DJNZ   R3,TMCHK2
         DJNZ   R2,TMCHK1
         CLR    C
         RET

TMCHK5:  JNB    TMDAT,$
         MOV    R2,#8
         DJNZ   R2,$
         SETB   C
         RET

         END

